export declare type CANProvince = 'Ontario' | 'Quebec' | 'New Brunswick' | 'Nova Scotia' | 'Newfoundland and Labrador' | 'Prince Edward Island' | 'Manitoba' | 'Saskatchewan' | 'British Columbia' | 'Northwest Territories' | 'Nunavut' | 'Yukon Territory' | 'Alberta';
export declare type CANProvinceOrNone = CANProvince | 'none';
export { CANProvince as CanadianProvince };
export { CANProvinceOrNone as CanadianProvinceOrNone };
export declare type ProvinceOrNoneObject = {
    [key: string]: CANProvinceOrNone;
};
/**
 * Canadian provinces and territories list. Maps abbreviation to name.
 */
export declare const CANProvinces: Readonly<{
    on: "Ontario";
    qc: "Quebec";
    nb: "New Brunswick";
    ns: "Nova Scotia";
    pe: "Prince Edward Island";
    mb: "Manitoba";
    sk: "Saskatchewan";
    bc: "British Columbia";
    nt: "Northwest Territories";
    nu: "Nunavut";
    yt: "Yukon Territory";
    ab: "Alberta";
    nl: "Newfoundland and Labrador";
}>;
/**
 * Canadian provinces & territories list, including none as an option. Maps abbreviation to name.
 */
export declare const CANProvincesOrNone: Readonly<Readonly<{
    on: "Ontario";
    qc: "Quebec";
    nb: "New Brunswick";
    ns: "Nova Scotia";
    pe: "Prince Edward Island";
    mb: "Manitoba";
    sk: "Saskatchewan";
    bc: "British Columbia";
    nt: "Northwest Territories";
    nu: "Nunavut";
    yt: "Yukon Territory";
    ab: "Alberta";
    nl: "Newfoundland and Labrador";
}> & {
    none: "none";
}>;
export { CANProvinces as canadianProvinces };
export { CANProvincesOrNone as canadianProvincesOrNone };
